/*******************************************************************************
 * FoxItemCacheClan generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxItemCacheClan extends FoxCacheSocialBase
    native;

enum EClanUpdateType
{
    ECUT_Disbanded,
    ECUT_Expanded,
    ECUT_MOTDUpdated,
    ECUT_MemberUpdated,
    ECUT_MAX
};

struct native ClanInfo
{
    var string ClanID;
    var string ClanName;
    var string ClanTag;
    var string MOTD;
    var string Founded;
    var int MemberCount;
    var int MemberLimit;
    var bool bHasClanPermissions;
    var byte MyRank;
    var array<ClanMemberDisplayInfo> ClanMembers;
    var array<ClanMemberDisplayInfo> AcceptedClanMembers;

    structdefaultproperties
    {
        ClanID=""
        ClanName=""
        ClanTag=""
        MOTD=""
        Founded=""
        MemberCount=0
        MemberLimit=0
        bHasClanPermissions=false
        MyRank=0
        ClanMembers=none
        AcceptedClanMembers=none
    }
};

struct native ClanInviteInfo
{
    var ClanInfo Clan;
    var UniqueNetId InviterId;
    var string InviterName;
    var string sClanName;
    var string sClanTag;
    var string sInvitedBy;
    var string sMemberCount;

    structdefaultproperties
    {
        Clan=(ClanID="",ClanName="",ClanTag="",MOTD="",Founded="",MemberCount=0,MemberLimit=0,bHasClanPermissions=false,MyRank=0,ClanMembers=none,AcceptedClanMembers=none)
        InviterId=(Uid=none)
        InviterName=""
        sClanName=""
        sClanTag=""
        sInvitedBy=""
        sMemberCount=""
    }
};

var array<ClanInviteInfo> CachedClanInvites;
var private ClanInfo CachedClanInfo;
var private ClanInfo OldCachedClanInfo;
var bool bIsRefreshing;
var delegate<PostRefresh> __PostRefresh__Delegate;
var delegate<PostMemberUpdate> __PostMemberUpdate__Delegate;
var delegate<PostUpdate> __PostUpdate__Delegate;
var delegate<PumpSocialNotificationDelegate> __PumpSocialNotificationDelegate__Delegate;

delegate PostRefresh(FoxItemCacheClan ClanCache)
{
    //return;    
}

delegate PostMemberUpdate(byte UpdateType, ClanMemberDisplayInfo OldInfo, ClanMemberDisplayInfo NewInfo)
{
    //return;    
}

delegate PostUpdate(FoxItemCacheClan.EClanUpdateType UpdateType, ClanInfo UpdatedClan)
{
    //return;    
}

delegate PumpSocialNotificationDelegate(FoxTypes.ESocialNotificationType NotificationType, optional string InstigatorPlayerName, optional EmblemPanelEntry EmblemInfo, optional string AdditionalInfo)
{
    //return;    
}

function Cleanup()
{
    local ClanInfo EmptyClanInfo;

    CachedClanInfo = EmptyClanInfo;
    super(FoxItemCacheBase).Cleanup();
    bIsRefreshing = false;
    //return;    
}

function bool IsDirty()
{
    return true;
    //return ReturnValue;    
}

function SetupDelegates()
{
    OnlineSub.ClanInterface.AddOnGetClanInfo(ParseClanInfo);
    OnlineSub.ClanInterface.AddClanGameInviteReceivedDelegate(OnClanGameInviteReceived);
    OnlineSub.ClanInterface.AddClanGameInviteExpiredDelegate(OnClanGameInviteExpired);
    OnlineSub.ClanInterface.AddOnClanInviteReceivedDelegate(OnClanInviteReceived);
    OnlineSub.ClanInterface.AddOnClanUpdatedDelegate(OnClanUpdatedDelegate);
    OnlineSub.ClanInterface.AddOnClanMemberUpdate(UpdateClanMember);
    OnlineSub.StoreInterface.AddPresenceUpdatedDelegate(OnPresenceUpdated);
    OnlineSub.ClanInterface.AddOnClanExpandedDelegate(OnClanExpanded);
    //return;    
}

function CleanupDelegates()
{
    OnlineSub.ClanInterface.ClearOnGetClanInfo(ParseClanInfo);
    OnlineSub.ClanInterface.ClearOnClanMemberUpdate(UpdateClanMember);
    OnlineSub.ClanInterface.ClearClanGameInviteReceivedDelegate(OnClanGameInviteReceived);
    OnlineSub.ClanInterface.ClearClanGameInviteExpiredDelegate(OnClanGameInviteExpired);
    OnlineSub.ClanInterface.ClearOnClanInviteReceivedDelegate(OnClanInviteReceived);
    OnlineSub.ClanInterface.ClearOnClanUpdatedDelegate(OnClanUpdatedDelegate);
    OnlineSub.StoreInterface.ClearPresenceUpdatedDelegate(OnPresenceUpdated);
    OnlineSub.ClanInterface.ClearOnClanExpandedDelegate(OnClanExpanded);
    __PostRefresh__Delegate = None;
    __PostMemberUpdate__Delegate = None;
    __PostUpdate__Delegate = None;
    __PumpSocialNotificationDelegate__Delegate = None;
    //return;    
}

function Invalidate()
{
    //return;    
}

function ClanInfo GetInfo()
{
    return CachedClanInfo;
    //return ReturnValue;    
}

function ClearInfo()
{
    local ClanInfo BlankInfo;

    CachedClanInfo = BlankInfo;
    //return;    
}

function SetMOTD(string NewMOTD)
{
    CachedClanInfo.MOTD = NewMOTD;
    //return;    
}

function bool IsInClan()
{
    return CachedClanInfo.ClanTag != "";
    //return ReturnValue;    
}

protected function bool RefreshCache()
{
    // End:0x5D
    if(!bIsRefreshing)
    {
        bIsRefreshing = true;
        CacheOldClanInfo();
        return OnlineSub.ClanInterface.GetClanInfo("");
    }
    return true;
    //return ReturnValue;    
}

private final function CacheOldClanInfo()
{
    // End:0x36
    if(CachedClanInfo.ClanMembers.Length > 0)
    {
        OldCachedClanInfo = CachedClanInfo;
    }
    //return;    
}

private final function OnClanExpanded(int NewMemberLimit)
{
    CachedClanInfo.MemberLimit = NewMemberLimit;
    //return;    
}

function DetermineClanPermissions(string ToFind)
{
    local ClanMemberDisplayInfo Member;

    // End:0xCD
    foreach CachedClanInfo.ClanMembers(Member,)
    {
        // End:0xCC
        if(Member.sName == ToFind)
        {
            CachedClanInfo.MyRank = Member.PositionInClan;
            CachedClanInfo.bHasClanPermissions = CachedClanInfo.MyRank <= 1;
        }        
    }    
    //return;    
}

// Export UFoxItemCacheClan::execParseClanInfo(FFrame&, void* const)
native function ParseClanInfo(string ClanInfoString);

function SetPostRefreshDelegate(delegate<PostRefresh> InDel)
{
    __PostRefresh__Delegate = InDel;
    //return;    
}

function SetUpdatedDelegate(delegate<PostUpdate> InDel)
{
    __PostUpdate__Delegate = InDel;
    //return;    
}

function SetPostUpdateMemberDelegate(delegate<PostMemberUpdate> InDel)
{
    __PostMemberUpdate__Delegate = InDel;
    //return;    
}

function SetPumpSocialNotificationDelegate(delegate<PumpSocialNotificationDelegate> InDel)
{
    __PumpSocialNotificationDelegate__Delegate = InDel;
    //return;    
}

event CallPumpSocialNotificationDelegate(FoxTypes.ESocialNotificationType NotificationType, optional string InstigatorPlayerName, optional EmblemPanelEntry EmblemInfo, optional string AdditionalInfo)
{
    // End:0x49
    if(__PumpSocialNotificationDelegate__Delegate != none)
    {
        PumpSocialNotificationDelegate(NotificationType, InstigatorPlayerName, EmblemInfo, AdditionalInfo);
    }
    //return;    
}

// Export UFoxItemCacheClan::execParseClanInvite(FFrame&, void* const)
native function ClanInviteInfo ParseClanInvite(string InInfo);

function OnClanInviteReceived(string InInfo)
{
    local ClanInviteInfo Info;

    Info = ParseClanInvite(InInfo);
    CachedClanInvites.AddItem(Info);
    CallPumpSocialNotificationDelegate(33, Info.Clan.ClanName);
    // End:0x93
    if(__PostRefresh__Delegate != none)
    {
        PostRefresh(self);
    }
    //return;    
}

// Export UFoxItemCacheClan::execOnClanUpdated(FFrame&, void* const)
native function bool OnClanUpdated(byte UpdateType, string NewClanInfo);

function OnClanUpdatedDelegate(byte UpdateType, string NewClanInfo)
{
    local bool bResult;

    bResult = OnClanUpdated(UpdateType, NewClanInfo);
    // End:0x6A
    if(bResult && __PostUpdate__Delegate != none)
    {
        PostUpdate(UpdateType, CachedClanInfo);
    }
    //return;    
}

// Export UFoxItemCacheClan::execNativeUpdateClanMember(FFrame&, void* const)
native function NativeUpdateClanMember(byte UpdateType, string MemberInfo, out ClanMemberDisplayInfo OldDisplayInfo, out ClanMemberDisplayInfo NewDisplayInfo);

function UpdateClanMember(byte UpdateType, string MemberInfo)
{
    local int I;
    local bool bIsStillInClan;
    local UniqueNetId MyId;
    local bool bUpdateUIImmediately;
    local ClanMemberDisplayInfo OldInfo, NewInfo;

    NativeUpdateClanMember(UpdateType, MemberInfo, OldInfo, NewInfo);
    bUpdateUIImmediately = true;
    // End:0x13F
    if(UpdateType == 1)
    {
        bIsStillInClan = false;
        PlayerInterface.GetUniquePlayerId(0, MyId);
        I = 0;
        J0x8D:
        // End:0x123 [Loop If]
        if(I < CachedClanInfo.ClanMembers.Length)
        {
            // End:0x115
            if(CachedClanInfo.ClanMembers[I].UniqueId == MyId)
            {
                bIsStillInClan = true;
                // [Explicit Break]
                goto J0x123;
            }
            ++ I;
            J0x123:
            // [Loop Continue]
            goto J0x8D;
        }
        // End:0x13C
        if(!bIsStillInClan)
        {
            ClearInfo();
        }
    }
    // End:0x17A
    else
    {
        // End:0x17A
        if(UpdateType == 0)
        {
            CacheOldClanInfo();
            ClearInfo();
            RefreshCache();
            bUpdateUIImmediately = false;
        }
    }
    // End:0x1D7
    if(bUpdateUIImmediately)
    {
        // End:0x1B4
        if(__PostUpdate__Delegate != none)
        {
            PostUpdate(3, CachedClanInfo);
        }
        // End:0x1D7
        if(__PostRefresh__Delegate != none)
        {
            PostRefresh(self);
        }
    }
    // End:0x214
    if(__PostMemberUpdate__Delegate != none)
    {
        PostMemberUpdate(UpdateType, OldInfo, NewInfo);
    }
    //return;    
}

event bool IsThisUserMe(UniqueNetId UserId)
{
    local UniqueNetId MyUserId;

    PlayerInterface.GetUniquePlayerId(0, MyUserId);
    return UserId == MyUserId;
    //return ReturnValue;    
}

event RestorePresence()
{
    local ClanMemberDisplayInfo OldMember, ScriptCompilerWorkaround;
    local int I;

    // End:0x484
    foreach OldCachedClanInfo.ClanMembers(OldMember,)
    {
        // End:0x483
        if(OldMember.PositionInClan < 4)
        {
            I = 0;
            J0x5A:
            // End:0x269 [Loop If]
            if(I < CachedClanInfo.ClanMembers.Length)
            {
                // End:0x25B
                if(CachedClanInfo.ClanMembers[I].UniqueId == OldMember.UniqueId)
                {
                    CachedClanInfo.ClanMembers[I].OnlineStatus = OldMember.OnlineStatus;
                    CachedClanInfo.ClanMembers[I].PresenceData = OldMember.PresenceData;
                    CachedClanInfo.ClanMembers[I].LastSeenString = OldMember.LastSeenString;
                    ScriptCompilerWorkaround = CachedClanInfo.ClanMembers[I];
                    MarkUpClanPresence(ScriptCompilerWorkaround);
                    CachedClanInfo.ClanMembers[I] = ScriptCompilerWorkaround;
                }
                ++ I;
                // [Loop Continue]
                goto J0x5A;
            }
            I = 0;
            J0x274:
            // End:0x483 [Loop If]
            if(I < CachedClanInfo.AcceptedClanMembers.Length)
            {
                // End:0x475
                if(CachedClanInfo.AcceptedClanMembers[I].UniqueId == OldMember.UniqueId)
                {
                    CachedClanInfo.AcceptedClanMembers[I].OnlineStatus = OldMember.OnlineStatus;
                    CachedClanInfo.AcceptedClanMembers[I].PresenceData = OldMember.PresenceData;
                    CachedClanInfo.AcceptedClanMembers[I].LastSeenString = OldMember.LastSeenString;
                    ScriptCompilerWorkaround = CachedClanInfo.AcceptedClanMembers[I];
                    MarkUpClanPresence(ScriptCompilerWorkaround);
                    CachedClanInfo.AcceptedClanMembers[I] = ScriptCompilerWorkaround;
                }
                ++ I;
                // [Loop Continue]
                goto J0x274;
            }
        }        
    }    
    //return;    
}

event RefreshClanUI()
{
    // End:0x23
    if(__PostRefresh__Delegate != none)
    {
        PostRefresh(self);
    }
    //return;    
}

// Export UFoxItemCacheClan::execParseUpdatedClanMember(FFrame&, void* const)
native function ClanMemberDisplayInfo ParseUpdatedClanMember(string MemberInfo);

// Export UFoxItemCacheClan::execMarkUpClanPresence(FFrame&, void* const)
native function MarkUpClanPresence(out ClanMemberDisplayInfo ClanMember);

event MarkUpClanMember(out ClanMemberDisplayInfo ClanMember)
{
    local string MapName;
    local int RankIndex;

    // End:0x76
    if(ClanMember.PositionInClan == 0)
    {
        ClanMember.sClanIcon = class'ZeMovieBase'.static.MarkupImageString("Menu.t_clanLeader");
    }
    // End:0x10C
    else
    {
        // End:0xED
        if(ClanMember.PositionInClan == 1)
        {
            ClanMember.sClanIcon = class'ZeMovieBase'.static.MarkupImageString("Menu.t_clanOfficer");
        }
        // End:0x10C
        else
        {
            ClanMember.sClanIcon = "";
        }
    }
    RankIndex = class'FoxUnlockInfo'.static.CalcRankIndexFromRawRank(ClanMember.Experience);
    ClanMember.Level = RankIndex;
    ClanMember.sLevel = string(RankIndex + 1);
    class'FoxProfileSettings'.static.DecodeEmblem(ClanMember.BadgeInfo, ClanMember.EmblemComponents);
    class'FoxUI'.static.BuildEmblemFromComponents(ClanMember.EmblemComponents, ClanMember.EmblemInfo);
    // End:0x382
    if(ClanMember.OnlineStatus == 8)
    {
        MapName = MenuItemsDataStore.GetMapNameByIndex(ClanMember.MapContext);
        // End:0x382
        if((MapName != "") && ClanMember.GameType != "")
        {
            ClanMember.sStatus = ApplyOnlineColor((ClanMember.GameType @ "//") @ MapName, ClanMember.bInvitedYou, ClanMember.Password != "");
        }
    }
    ClanMember.sTitle = class'FoxUnlockInfo'.static.GetTitleFromUnlockID(ClanMember.TitleInfo, RankIndex);
    //return;    
}

function OnClanGameInviteReceived(UniqueNetId InviterId)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xCE [Loop If]
    if(I < CachedClanInfo.ClanMembers.Length)
    {
        // End:0xC0
        if(CachedClanInfo.ClanMembers[I].UniqueId == InviterId)
        {
            CachedClanInfo.ClanMembers[I].bInvitedYou = true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    // End:0xF1
    if(__PostRefresh__Delegate != none)
    {
        PostRefresh(self);
    }
    //return;    
}

function OnClanGameInviteExpired(UniqueNetId InviterId)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xCE [Loop If]
    if(I < CachedClanInfo.ClanMembers.Length)
    {
        // End:0xC0
        if(CachedClanInfo.ClanMembers[I].UniqueId == InviterId)
        {
            CachedClanInfo.ClanMembers[I].bInvitedYou = false;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    // End:0xF1
    if(__PostRefresh__Delegate != none)
    {
        PostRefresh(self);
    }
    //return;    
}

// Export UFoxItemCacheClan::execOnPresenceUpdated(FFrame&, void* const)
native function OnPresenceUpdated(UniqueNetId UserId, int State, string Presence, string LastSeen);

function int GetMemberIndexFromID(UniqueNetId UniqueId)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x9C [Loop If]
    if(I < CachedClanInfo.ClanMembers.Length)
    {
        // End:0x8E
        if(CachedClanInfo.ClanMembers[I].UniqueId == UniqueId)
        {
            return I;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return -1;
    //return ReturnValue;    
}

function int GetMemberIndexFromPlayerName(string PlayerName)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x95 [Loop If]
    if(I < CachedClanInfo.ClanMembers.Length)
    {
        // End:0x87
        if(CachedClanInfo.ClanMembers[I].sName == PlayerName)
        {
            return I;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return -1;
    //return ReturnValue;    
}
